#include <algorithm>
#include <numeric>
#include <vector>
#include <cstdio>

using namespace std;

int main() {
    vector<int> V;
    
    while(true) {
        int a;
        scanf("%d", &a);
        if(a == 0) break;
        V.push_back(a);
    }
    
    printf("Tamanho              : %d\n", V.size());
    
    /* ordenação */
    sort(V.begin(), V.end());
    printf("Elementos ordenados  : ");
    
    for(int i = 0, e = V.size(); i < e; ++i)
        printf("%d ", V[i]);
    printf("\n");
    
    /* buscas */
    printf("Menor elemento       : %d\n", *min_element( V.begin(), V.end() )   );
    printf("Maior elemento       : %d\n", *max_element( V.begin(), V.end() )   );
    
    /* busca linear */
    vector<int>::iterator it = find( V.begin(), V.end(), 100 );
    printf("Busca linear por 100 : %s!\n", find(V.begin(), V.end(), 100) != V.end() ? "encontrou" : "não encontrou");
        
    /* busca binária */
    printf("Busca binária por 100: %s!\n", binary_search(V.begin(), V.end(), 100) ? "encontrou" : "não encontrou");
    
    /* busca binária: lower_bound */
    printf("Elementos >= a 100   : ");
    it = lower_bound( V.begin(), V.end(), 100);
    for(vector<int>::iterator eit = V.end(); it != eit; ++it)
        printf("%d ", *it);
    printf("\n");
    
    return 0;
}
